package de.cnc.flowprogram;

/**
 * Struktur-Klasse fr Value-Parameter und Reference-Parameter . <br/>
 * Dieser Parameter wird von der Prcedure-Deklarations-Seite aus gesehen.
 * 
 * @see FlowControlCompiler
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class FlowProcDeclParam
{
    /**
     * Schalter Reference-Parameter (alternativ Value-Parameter)
     */
    public boolean isRefParam = false;

    /**
     * Session-Key innerhalb der procedure fr Reference-Parameter (werden bei return von diesem Session-Key zurckkopiert)
     */
    public String insideKey;

    /**
     * 
     */
    public String toString()
    {
        return "[" + this.getClass().getName() 
                + " isRefParam: " + isRefParam
                + " insideKey: " + insideKey
                + "]";
    }

}
