package de.cnc.persistens;

/**
 * Exception-Klasse fr Fehler in
 * {@link de.cnc.server.DatabaseStore} und
 * {@link de.cnc.server.PersistensHelper} . <br/>
 * Enthlt teilweise nicht mehr notwendige Fehlerstati aus altem Code. <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: DatabaseStoreException.java,v 1.1 2004/09/30 12:32:02 aex116e Exp $
 */
public class DatabaseStoreException extends Exception
{
  //public final static String  UpdateNotSupported = "Update function is not supported.\nDatabaseObject does not overwrite getUpdateSQLStatement()";
  //public final static String  InsertNotSupported = "Insert function is not supported.\nDatabaseObject does not overwrite getInsertSQLStatement()";
  //public final static String  DeleteNotSupported = "Delete function is not supported.\nDatabaseObject does not overwrite getDeleteSQLStatement()";
  //public final static String  SelectForUpdateNotSupported = "SelectForUpdate function is not supported.\nDatabaseObject does not overwrite getSelectForUpdateSQLStatement()";
  //public final static String  DataChanged = "Data of DatabaseObject have chaned from someone else";
  //public final static String  FunctionNotSupported = "Function is not supported!";
  public final static String  InTransaction = "Store is just in Transaction!";
  //public final static String  PreparedStatementNotSupported = "PreparedStatement is not supported.\nDatabaseObject does not overwrite the prepared funktions";
  //public final static String  StoreNotSupported = "Store function is not supported.\nDatabaseObject does not overwrite getDeleteSQLStatement()";
  //public final static String  StoreBlobFailed = "Store BLOB failed";
  //public final static String  StoreClobFailed = "Store CLOB failed";

  /**
   * parameterloser Konstruktor
   */
  public DatabaseStoreException()
  {
    super();
  }

  /**
   * Konstruktor fr spezifische Exception
   *
   * @param s
   */
  public DatabaseStoreException(String s)
  {
    super(s);
  }

}//end class DatabaseStoreException
