package de.cncdemo.formbeans;

/**
 * FormBean (Formular-Bean) fr eine Aktie im
 * JspSpreadsheet-Demo in der CncDemo-Applikation . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public final class AktieFormBean {

    private String name;

    private int anzahl;

    private double preis;

    /**
     * @return
     */
    public int getAnzahl()
    {
        return anzahl;
    }

    /**
     * @return
     */
    public String getName()
    {
        return name;
    }

    /**
     * @return
     */
    public double getPreis()
    {
        return preis;
    }

    /**
     * @param i
     */
    public void setAnzahl(int i)
    {
        anzahl = i;
    }

    /**
     * @param string
     */
    public void setName(String string)
    {
        name = string;
    }

    /**
     * @param d
     */
    public void setPreis(double d)
    {
        preis = d;
    }

    public String toString() {
      return /*getClass().getName() + " " +*/ "[Name: " + name + ", Anzahl: " + anzahl + ", Preis: " + preis + "]";
    }// end method toString

    
    /**
     * Fr Ausgabe Gesamtpreis in der Liste . <br>
     * 
     * @return
     */
    public double getGesamt()
    {
        return anzahl * preis;
    }

}// end class AktieFormBean
