//****************************************************************************************
procedure main()
{
  logon  // im Body der logon-Deklaration ist die User-Validierung ausgeschalten, damit ein Einloggen berhaupt mglich ist
  {
    // Logon immer wieder anbieten, bis ok
    while ( session:USER != "USER" )
    {
      if ( session:CNC_INFO_MESSAGE == null )
      {
        session:CNC_INFO_MESSAGE := "JavaScript is " + if( request:param:CNC_JAVASCRIPT == 'on' , 'on' , 'off' );
      }
      jsp( "/logon.jsp" );
      action( "logon" );
    } //while
  } //logon

  // Einstiegspunkt Applikation
  // Logon und User-Validierung mssen hier schon gelaufen sein
  label begin;

  //Aufrumen
  session:CNC_FORM_KEY := null;
  session:CNC_LIST_KEY := null;

  while ( true ) // Endlos-Schleife
  {
    if ( session:CNC_INFO_MESSAGE == null )
    {
      session:CNC_INFO_MESSAGE := "JavaScript is " + if( request:param:CNC_JAVASCRIPT == 'on' , 'on' , 'off' );
    }

    jsp( "/mainmenu.jsp" );

    action( "clearSession" );

    if ( cnc_link == "blaettern" )
    {
      call blaettern();
    }
    else if ( cnc_link == "suchen" )
    {
      call suchen();
    }
    else if ( cnc_link == "liste_edit" )
    {
      call liste_edit();
    }
    else if ( cnc_link == "jsp_spreadsheet" )
    {
      call jsp_spreadsheet();
    }
    else if ( cnc_link == "date" )
    {
      call date();
    }
    else if ( cnc_link == "date_range" )
    {
      call date_range();
    }
    else if ( cnc_link == "date_validator" )
    {
      call date_validator();
    }
    else if ( cnc_link == "localvar" )
    {
      session:CNC_INFO_MESSAGE := "Test localvar: Achten Sie bitte auf die Session-Variable localvartest";
      jsp ( "/cncdebug/show.jsp" );
      session:localvartest := 'outside';
      session:CNC_INFO_MESSAGE := "Test localvar: Session-Variable localvartest vor CALL.<br><br>localvar wurde auf den Wert 'outside' gesetzt";
      jsp ( "/cncdebug/show.jsp" );
      call localvar();
      if ( session:localvartest != 'outside' )
      {
        session:CNC_ERROR_MESSAGE := "Test failed !!!";
      }
      else
      {
        session:CNC_INFO_MESSAGE := "Test localvar: Session-Variable localvartest nach RETURN.<br><br>localvar hat wieder den Wert 'outside'.";
      }
      jsp ( "/cncdebug/show.jsp" );
      reset ( "session:localvartest" );
    }
    else if ( cnc_link == "param" )
    {
      session:testparamoutside := "pervalue";

      session:CNC_INFO_MESSAGE := "Test value-parameter: Session-Variable testparamoutside vor CALL.<br><br>Variable testparamoutside auf 'pervalue' gesetzt.<br><br>testparamoutside: " + session:testparamoutside;
      jsp ( "/cncdebug/show.jsp" );

      call valueparamtest( session:testparamoutside );

      session:CNC_INFO_MESSAGE := "Test value-parameter: Session-Variable testparamoutside nach RETURN.<br><br>Variable testparamoutside hat wieder den Wert 'pervalue'.<br><br>testparamoutside: " + session:testparamoutside;
      jsp ( "/cncdebug/show.jsp" );

      reset ( "session:testparamoutside" );
    }
    else if ( cnc_link == "refparam" )
    {
      session:testparamoutside := "perreference";

      session:CNC_INFO_MESSAGE := "Test reference-parameter: Session-Variable testparamoutside vor CALL<br><br>testparamoutside: " + session:testparamoutside;
      jsp ( "/cncdebug/show.jsp" );

      call refparamtest( session:testparamoutside );

      if ( session:testparamoutside != 'changed' )
      {
        session:CNC_ERROR_MESSAGE := "Test failed !!!";
      }
      else
      {
        session:CNC_INFO_MESSAGE := "Test reference-parameter: Session-Variable testparamoutside nach RETURN<br><br>testparamoutside: " + session:testparamoutside;
      }
      jsp ( "/cncdebug/show.jsp" );

      reset ( "session:testparamoutside" );
    }

    else if ( cnc_link == "returnvalue" )
    {
      //reset sessionKey="testparamoutside ;

      session:CNC_INFO_MESSAGE := "Session-Variable test_return_outside existiert vor CALL nicht<br>session:test_return_outside: " + session:test_return_outside;
      jsp ( "/cncdebug/show.jsp" );

      session:test_return_outside := call returnvaluetest ();

      if ( session:test_return_outside != "returnvalue" )
      {
        session:CNC_INFO_MESSAGE := "Test failed<br>session:test_return_outside: " + session:test_return_outside;
      }
      else
      {
        session:CNC_INFO_MESSAGE := "Session-Variable test_return_outside nach RETURN<br>session:test_return_outside: " + session:test_return_outside;
      }
      jsp ( "/cncdebug/show.jsp" );
    } // else if
    else if ( cnc_link == "rekursion" )
    {
      session:CNC_INFO_MESSAGE := "Die Prozedur rekursion wird 4-mal aufgerufen bis der Parameter rekursivparam auf 4 incrementiert wurde";
      jsp ( "/cncdebug/show.jsp" );
      call rekursion ( 0 );
    } // else if
    else if ( cnc_link == "impl_action" )
    {
      call impl_action();
    } // else if
    else if ( cnc_link == "singlestepon" )
    {
      session:CNC_SINGLE_STEP_DEBUG := "ON";
    } // else if
    else if ( cnc_link == "singlestepoff" )
    {
      reset ( "session:CNC_SINGLE_STEP_DEBUG" );
    } // else if
    else if ( cnc_link == "bestellung" )
    {
      call bestellapp();
    } // else if
    else if ( cnc_link == "expression" )
    {
      call expression();
    } // else if
    else if ( cnc_link == "farbwahl" )
    {
      call farbwahl();
    } // else if
    else if ( cnc_link == "frames" )
    {
      jsp( "/frames/frame_main.jsp" );
    } // else if
    else if ( cnc_link == "tree_simple" )
    {
      call tree_simple();
    } // else if
    else if ( cnc_link == "tree_frames" )
    {
      jsp( "/tree_frames/frame_tree_main.jsp" );
    } // else if
    else
    {
      session:CNC_ERROR_MESSAGE := "unbekannte Action: " + cnc_link + " " + cnc_button + " !!!" ;
      jsp ( "/cncdebug/show.jsp" );
    }
  } // while

  // Sprungmarke fr Navigationslink Logout
  // wird im normalen Durchlauf wegen Endlos-Schleife nie erreicht
  label logout;
  reset ( '' ); // lscht alle Session-Variablen
  session:CNC_INFO_MESSAGE := "Sie wurden ordnungsgemss abgemeldet";
  // jsp( "/logon.jsp" );

} // end main
//****************************************************************************************
procedure blaettern()
{
  /*
     +-------------------+
     |                   |
     |   blaettern.jsp   |<-----------------------+
     |                   |                        |
     +-------------------+                        |
              |                                   |
              |        +-------------------+      |
              |        |       next        |      |
              +------->|                   |------+
              |        |  page++ (max 10)  |      |
              |        +-------------------+      |
              |                                   |
              |        +-------------------+      |
              |        |       prev        |      |
              +------->|                   |------+
                       |  page-- (min 0)   |
                       +-------------------+
  */
  session:page := 1;
  while( true ) // Endlos-Schleife
  {
    jsp ( "/blaettern/blaettern.jsp" );

    // Test Links
    if ( cnc_link == "prev" )
    {
      if ( session:page > 0 )
      {
        session:page-- ;
      }
      else
      {
        session:CNC_INFO_MESSAGE := "Minimum erreicht, Link" ;
      }
    } // elseif
    else if ( cnc_link == "next" )
    {
      if ( session:page < 10 )
     {
        session:page++ ;
      }
      else
      {
        session:CNC_INFO_MESSAGE := "Maximum erreicht, Link" ;
      }
    } // elseif

    // Test Buttons
    else if ( cnc_button == "prev" )
    {
      if ( session:page > 0 )
      {
        session:page-- ;
      }
      else
      {
        session:CNC_INFO_MESSAGE := "Minimum erreicht, Button" ;
      }
    } // elseif
    else if ( cnc_button == "next" )
    {
      if ( session:page < 10 )
      {
        session:page++ ;
      }
      else
      {
        session:CNC_INFO_MESSAGE := "Maximum erreicht, Button" ;
      }
    } // elseif
  } // while
} // end blaettern
//***************************************************************************************
procedure suchen()
{
  /*
     +-------------------+
     |                   |
     |    suchen.jsp     |<------------------------------------------------------------------+
     |                   |                                                                   |
     +-------------------+                                                                   |
              |                                                                              |
              |                                                                              |
     +-------------------+                                                                   |
     |                   |                                                                   |
     |   suche-action    |                                                                   |
     |                   |                                                                   |
     +-------------------+                                                                   |
              |                                                                              |
              |                                                   +-----------------------+  |
              |                                                   |                       |  |
              +-- kein Treffer ---------------------------------->|  suche_erfolglos.jsp  |--+
              |                                                   |                       |  |
              |                                                   +-----------------------+  |
              |                                                                              |
              |                                                   +-----------------------+  |
              |                                                   |                       |  |
              +-- genau ein Treffer -------------------------+--->| anzeige_datensatz.jsp |--+
              |                                              |    |                       |
              |                                              |    +-----------------------+
              |                                              |
              |                       +-------------------+  |
              |                       |                   |  |
              +-- mehrere Treffer --->| treffer_liste.jsp |--+
                                      |                   |
                                      +-------------------+
  */
  do ( true ) // Endlos-Schleife
  {
    session:such_treffer := ""; // reset sessionKey such_treffer
    jsp ( "/suchen/suchen.jsp" );

    action ( "suchen" ) ; // speichert Trefferanzahl in der Session

    if ( session:such_treffer < 1 )
    {
      // kein Treffer
      jsp ( "/suchen/suche_erfolglos.jsp" );
    }
    else if ( session:such_treffer == 1 )
    {
      // genau ein Treffer
      session:show_name := "Genau1TrefferName" ;
      jsp ( "/suchen/anzeige_datensatz.jsp" );
    }
    else
    {
      // mehrere Treffer
      jsp ( "/suchen/treffer_liste.jsp" );

      session:show_name := cnc_action ; // gewhlten Namen zwischenspeichern

      // weiter zum konkreten Treffer aus der Trefferliste
      jsp ( "/suchen/anzeige_datensatz.jsp" );
    } //else
  } // do
} // end suchen
// ****************************************************************************************
procedure liste_edit()
{
  action ( "setListeInSession" );

  while (true) // Endlos-Schleife
  {
    jsp ( "/liste_edit/liste_edit.jsp" );

    if ( cnc_button == "add" )
    {
      action ( "add" );
      session:CNC_FOCUS := "txt[" + ( length( session:CNC_LIST_KEY ) - 1 ) + "]";
    }
    else if ( cnc_button == "ins" )
    {
      action ( "ins" );
      session:CNC_FOCUS := "txt[" + cnc_button_index + "]";
    }
    else if ( cnc_button == "del" )
    {
      session:CNC_FORM_KEY := session:CNC_LIST_KEY[ cnc_button_index ]; // gewhltes Listenelement auf CNC_FORM_KEY kopieren
      session:CNC_INFO_MESSAGE := "Tabellenzeile " + cnc_button_index + " wirklich lschen?";
      jsp ( "/generic/del_ask.jsp" );
      if ( cnc_button == "del" )
      {
        //action ( "del" );
        action ( "deleFormListElement" );
      }
      session:CNC_FORM_KEY := null; // aufrumen
      session:CNC_FOCUS := "txt[" + cnc_button_index + "]";
    }
    else if ( cnc_button == "mvup" )
    {
      action ( "mvup" );
      session:CNC_FOCUS := "txt[" + ( cnc_button_index - 1 ) + "]";
    }
    else if ( cnc_button == "mvdn" )
    {
      action ( "mvdn" );
      session:CNC_FOCUS := "txt[" + ( cnc_button_index + 1 ) + "]";
    }
    else if ( cnc_button == "save" )
    {
      action ( "save" );
      session:CNC_INFO_MESSAGE := "Abspeichern auf Datenbank ist in dieser Demo-Version nicht mglich";
      jsp ( "/cncdebug/show.jsp" );
      return;
    }
  } // while
} // end liste_edit
//****************************************************************************************
procedure date()
{
  do(true) // Endlos-Schleife
  {
    jsp ( "/date/date.jsp" );
    session:date := request:param:date; // eingegebenes Datum zwischenspeichern
    if ( strToDate( session:date ) != null )
    {
      session:CNC_INFO_MESSAGE := "Datum '" + trim( session:date ) + "' ist korrekt"; // Setzen Meldung
      jsp ( "/cncdebug/show.jsp" );
      break;
    } //if
    session:CNC_ERROR_MESSAGE := "Bitte Datum korrigieren"; // Setzen Meldung
  } // do
} // end date
//****************************************************************************************
procedure date_range()
{
  while ( true ) // Endlos-Schleife
  {
    session:CNC_ERROR_MESSAGE := "Bitte Datum von 1.1.2004 bis 31.12.2004 eingeben";
    jsp ( "/date/date.jsp" );
    session:date := request:param:date; // eingegebenes Datum zwischenspeichern
    if (   ( strToDate( session:date ) >= strToDate( "1.1.2004" ) )  // if date >= 01.01.2004
        && ( strToDate( session:date ) <= strToDate( "31.12.2004" ) ) ) // if date <= 31.12.2004
    {
      session:CNC_INFO_MESSAGE := 'Datum "' + trim( session:date ) + '" ist korrekt'; // Setzen Meldung
      jsp ( "/cncdebug/show.jsp" );
      break; // Schleife beenden
    } // if
  } // while
} // end procedure daterange
//****************************************************************************************
procedure date_validator()
{
  while (true)
  {
    session:CNC_FORM_KEY := newObject( 'de.cncdemo.formbeans.DateValidatorFormBean' );
    session:CNC_INFO_MESSAGE := "Bitte Datum eingeben";
    jsp ( "/date/datevalidator.jsp" );
    session:CNC_INFO_MESSAGE := 'Datum "' + invokeMethod( session:CNC_FORM_KEY , 'getDate' ) + '" ist korrekt'; // Setzen Meldung
    jsp ( "/cncdebug/show.jsp" );
  }
} // end procedure date_validator
//****************************************************************************************
procedure localvar()
{
  /*

  +-------------------------------------------+
  | procedure main                            |
  |                                           |
  | Variable localvartest = outside           |
  |                                           |
  |  +-------------------------------------+  |
  |  | procedure localvar                  |  |
  |  |                                     |  |
  |  | Variable localvartest = inside      |  |
  |  |                                     |  |
  |  +-------------------------------------+  |
  |                                           |
  | return zu main                            |
  | Variable localvartest == outside          |
  |                                           |
  +-------------------------------------------+

  */
  local session:localvartest;

  session:CNC_INFO_MESSAGE := "procedure localvar: Session-Variable localvartest nach CALL.<br><br>Der Originalwert wird auf dem Stack des CNC-Systems zwischengespeichert.";
  jsp ( "/cncdebug/show.jsp" );

  session:localvartest := "inside";

  session:CNC_INFO_MESSAGE := "procedure localvar: Session-Variable localvartest nach Belegen mit neuem Wert.<br><br>localvar wurde auf den Wert 'inside' gesetzt.";
  jsp ( "/cncdebug/show.jsp" );

} // end procedure localvar
//****************************************************************************************
procedure valueparamtest( session:testparaminside )
{
  /*

  +-----------------------------------------------+
  | procedure main                                |
  |                                               |
  | Variable testparamoutside = pervalue          |
  |                                               |
  |  +-----------------------------------------+  |
  |  | procedure valueparamtest                |  |
  |  |                                         |  |
  |  | Parameter testparaminside == pervalue   |  |
  |  |                                         |  |
  |  | Parameter testparaminside = inside      |  |
  |  |                                         |  |
  |  +-----------------------------------------+  |
  |                                               |
  | return zu main                                |
  | Variable testparamoutside == pervalue         |
  |                                               |
  +-----------------------------------------------+

  */
  session:CNC_INFO_MESSAGE := "procedure valueparamtest(value-parameter): Parameter testparaminside nach CALL.<br><br>Der Originalwert wird auf dem Stack des CNC-Systems zwischengespeichert, <br>ist aber in der procedure sichtbar.";
  jsp ( "/cncdebug/show.jsp" );

  session:testparaminside := "inside";

  session:CNC_INFO_MESSAGE := "procedure valueparamtest(value-parameter): Parameter testparaminside gendert.<br><br>localvar wurde auf den Wert 'inside' gesetzt.";
  jsp ( "/cncdebug/show.jsp" );

} // end procedure paramtest
//****************************************************************************************
procedure refparamtest ( refparam session:refparam )
{
  /*
  +------------------------------------------------+
  | procedure main                                 |
  |                                                |
  | Variable testparamoutside = perreference       |
  |                                                |
  |  +------------------------------------------+  |
  |  | procedure paramtest                      |  |
  |  |                                          |  |
  |  | Parameter refparam == perreference       |  |
  |  |                                          |  |
  |  | Parameter refparam = changed             |  |
  |  |                                          |  |
  |  +------------------------------------------+  |
  |                                                |
  | return zu main                                 |
  | Variable testparamoutside == changed           |
  |                                                |
  +------------------------------------------------+
  */
  session:CNC_INFO_MESSAGE := "procedure refparamtest: Parameter refparam nach CALL";
  jsp ( "/cncdebug/show.jsp" );

  session:refparam := "changed";

  session:CNC_INFO_MESSAGE := "procedure refparamtest: Parameter refparam gendert";
  jsp ( "/cncdebug/show.jsp" );

} // end procedure refparamtest
//****************************************************************************************
function returnvaluetest()
{
  local session:returnkey;
  session:returnkey := "returnvalue";

  session:CNC_INFO_MESSAGE := "procedure returnvaluetest: Rckgabe Session-Variable returnkey<br>returnkey: " + session:returnkey;
  jsp ( "/cncdebug/show.jsp" );

  return ( session:returnkey );
} // end procedure returnvaluetest
//****************************************************************************************
procedure rekursion ( session:rekursivparam )
{
  /*
  Die Prozedur rekursion wird 4-mal aufgerufen bis
  der Parameter rekursivparam auf 4 incrementiert wurde
  */

  session:rekursivparam++ ; // um 1 erhhen

  session:CNC_INFO_MESSAGE := '' + session:rekursivparam;

  jsp ( "/cncdebug/show.jsp" );

  if ( session:rekursivparam < 4 ) // bis zur 4 wiederholen
  {
    call rekursion ( session:rekursivparam ) // rekursiver Aufruf
  } // if

  session:CNC_INFO_MESSAGE := '' + session:rekursivparam;

  jsp ( "/cncdebug/show.jsp" );

  return;
} // end procedure rekursion
//****************************************************************************************
procedure impl_action()
{
  /*
     +-------------------+
     |                   |<--------------+
     |  impl_action.jsp  |               |
     |                   |  +--------------------------+
     |                   |  |     implizite Action     |
     |                   |  |                          |
     |                   |  | de.cncdemo.implicit.Sort |
     |                   |  |                          |
     |                   |  +--------------------------+
     |                   |               |
     |                   |               |
     |                   |               |
     |                   |               |
     |                   |               |
     +-------------------+               |
              |                          |
              +--------------------------+
  */
  session:SORT_DIRECTION := "DN"; // Sortieren abwaerts
  action ( "getSortList" ); // Test-Liste erzeugen
  jsp ( "/impl_action/impl_action.jsp" );
} // end procedure impl_action
//****************************************************************************************
procedure bestellapp()
{
  jsp ( "/bestellapplication/welcome.jsp" );

  if ( session:ARTIKEL_LISTE == null )
  {
    action ( "Bestellung#getArtikelListe" ); // neue Artikel-Liste
    session:ARTIKEL_LISTE := session:CNC_LIST_KEY; // Artikel-Liste auf reserviertem Key ablegen
  } // if

  if ( session:BESTELLUNGEN_LISTE == null )
  {
    action ( "Bestellung#getBestellungenListe" ); // neue Bestellungen Erzeugen
    session:BESTELLUNGEN_LISTE := session:CNC_LIST_KEY; // Bestellungen auf reserviertem Key ablegen
  } // if

  while( true ) // Endlos-Schleife
  {
    jsp ( "/bestellapplication/bestellappmain.jsp" );

    if ( cnc_link == "artikelstamm" )
    {
      reset ( "session:CNC_FORM_KEY" ); // dafr sorgen, da kein vorgewhltes Element da ist
      call artikelstamm( null , false );
    }
    else if ( cnc_link == "bestellungen" )
    {
      call bestellungen();
    }
    else
    {
      return;
    } // if
  } // end while
} // end procedure bestellapp
//****************************************************************************************
procedure bestellungen()
{
  local session:CNC_LIST_KEY;
  local session:CNC_BROWSE_CTRL_KEY;

  while( true ) // Endlos-Schleife
  {
    session:CNC_LIST_KEY := session:BESTELLUNGEN_LISTE; // Bestellungen von reserviertem Key holen
    jsp ( "/bestellapplication/bestellungen/bestellungenliste.jsp" );
    if ( cnc_button == "edit" )
    {
      action ( "listElementToForm" );
      call singlebestellung( session:CNC_FORM_KEY );
    }
    else if ( cnc_button == "delete" )
    {
      session:CNC_FORM_KEY := session:CNC_LIST_KEY[ cnc_button_index ]; // gewhltes Listenelement auf CNC_FORM_KEY kopieren
      session:CNC_INFO_MESSAGE := "Bestellung "
                               + getProperty( session:CNC_FORM_KEY , "nr" ) + " "
                               + getProperty( session:CNC_FORM_KEY , "bezeichnung" )
                               + " wirklich lschen?";
      jsp ( "/generic/del_ask.jsp" );
      if ( cnc_button == "del" )
      {
        //action ( "del" );
        action ( "deleFormListElement" );
      }
    }
    else if ( cnc_button == "add" )
    {
      session:CNC_FORM_KEY := call newbestellung();

      if ( session:CNC_FORM_KEY != null )
      {
        action ( "addFormToList" );
        action ( "goLastPage" );
      } // if

    }
    else if ( cnc_button == "no_parse" )
    {
      return;
    }
  } // end while
} // end procedure singlebestellung
//****************************************************************************************
function newbestellung()
{
  local session:CNC_FORM_KEY;

  //set sessionKey="CNC_FORM_KEY" class="de.cncdemo.formbeans.BestellungFormBean"/  // neue Bestellung erzeugen

  action ( "Bestellung#newBestellung" ); // neue Bestellung erzeugen
  jsp ( "/bestellapplication/singlebestellung/bestellungform.jsp" );
  if ( cnc_button == "save" )
  {
    return ( session:CNC_FORM_KEY );
  }
  else if ( cnc_button == "no_parse" )
  {
    return ( null );
  } // if
} // end procedure newbestellung
//****************************************************************************************
procedure singlebestellung ( session:SINGLEBESTELLUNG_KEY )
{
  local session:CNC_LIST_KEY;
  local session:CNC_BROWSE_CTRL_KEY;

  action ( "Bestellung#setBestellPositionenToListKey" ); // Liste Bestell-Positionen auf CNC_LIST_KEY legen

  while( true ) // Endlos-Schleife
  {
    jsp ( "/bestellapplication/singlebestellung/bestellung.jsp" );

    if ( cnc_button == "add" )
    {
      reset ( "session:CNC_FORM_KEY" ); // dafr sorgen, da kein vorgewhltes Element da ist
      session:CNC_FORM_KEY := null; // analog zu RESET, keine Vorbelegung

      session:CNC_INFO_MESSAGE := "Bitte anzufgenden Artikel auswhlen";

      session:CNC_FORM_KEY := call artikelstamm (
        null, //session:CNC_FORM_KEY ,
        true /* Schalter fr Wahl-Modus */ );

      if ( cnc_button == "no_parse" ) // Abbruch-Button
      {
        continue;
      }
      action ( "Bestellung#addBestellPos" );
      action ( "goLastPage" );
    }
    else if ( cnc_button == "ins" )
    {
      action ( "Bestellung#saveIndex" ); // vermerken Nummer des Buttons (Index) auf dem Session-Key BESTELLUNG_INDEX
      reset ( "session:CNC_FORM_KEY" ); // dafr sorgen, da kein vorgewhltes Element da ist
      session:CNC_INFO_MESSAGE := "Bitte einzufgenden Artikel auswhlen";
      session:CNC_FORM_KEY := null; // analog zu RESET, keine Vorbelegung
      session:CNC_FORM_KEY := call artikelstamm (
        session:CNC_FORM_KEY ,
        true /* Schalter fr Wahl-Modus */ );

      if ( cnc_button == "no_parse" ) // Abbruch-Button
      {
        continue;
      }
      action ( "Bestellung#insBestellPos" );
    }
    else if ( cnc_button == "edit" ) // Bestell-Position (Artikel) Editieren
    {
      action ( "Bestellung#saveIndex" ); // vermerken Nummer des Buttons (Index) auf dem Session-Key BESTELLUNG_INDEX
      action ( "listElementToForm" ); // gewhltes Listenelement auf CNC_FORM_KEY kopieren
      action ( "Bestellung#getArtikelFromPosition" ); // Artikel-Objekt aus Positions-Objekt entnehmen
      session:CNC_INFO_MESSAGE := "Artikel Bearbeiten";
      session:CNC_FORM_KEY := call artikelstamm (
        session:CNC_FORM_KEY ,
        true /* Schalter fr Wahl-Modus */ );

      if ( cnc_button == "no_parse" ) // Abbruch-Button
      {
        continue;
      }
      action ( "Bestellung#setPosArtikel" );
    }
    else if ( cnc_button == "del" )
    {
      session:CNC_FORM_KEY := session:CNC_LIST_KEY[ cnc_button_index ]; // gewhltes Listenelement auf CNC_FORM_KEY kopieren
      session:CNC_INFO_MESSAGE := "Bestellungs-Position "
                               + getProperty(
                                   getProperty( session:CNC_FORM_KEY , "artikel" ) ,
                                   "bez" )
                               + " wirklich lschen?";
      jsp ( "/generic/del_ask.jsp" );
      if ( cnc_button == "del" )
      {
        //action ( "del" );
        action ( "deleFormListElement" );
      }
    }
    else if ( cnc_button == "mvup" )
    {
      action ( "mvup" );
    }
    else if ( cnc_button == "mvdn" )
    {
      action ( "mvdn" );
    }
    else if ( cnc_button == "save" )
    {
      return;
    } // if
  } // end while

} // end procedure singlebestellung
//****************************************************************************************
function artikelstamm ( /*refparam*/ session:artikel , session:wahl )
{
  /*
  Die Prozedur Artikelstamm erlaubt das
    Bearbeiten
    Anlegen
    Lschen
    Auswhlen
  von Artikeln der Bestell-Applikation

        |
   action Bestellung#getArtikelListe
        |
   +-------------------+
   |                   |
   | artikelliste.jsp  |<--------------------------------------------------------------------------------------+
   |                   |                                                                                       |
   +-------------------+                                                                                       |
        |                                                                                                      |
        |                                               +-----------------+                                    |
        |                                               |                 |                                    |
        +--- Bearbeiten --- action listElementToForm ---+ artikelform.jsp +------------------------------------+
        |                                               |                 |                                    |
        |                                               +-----------------+                                    |
        |                                                                                                      |
        |                                               +-----------------+                                    |
        |                                               |                 |                                    |
        +--- Anlegen ------ set class (Init) -----------+ artikelform.jsp +--- action addFormToList -----------+
        |                                               |                 |                                    |
        |                                               +-----------------+                                    |
        |                                                                                                      |
        |                                            +----------------------+                                  |
        |                                            |                      |                                  |
        +--- Lschen --- action listElementToForm ---+ artikeldeleteask.jsp +--- action deleFormListElement ---+
        |                                            |                      |
        |                                            +----------------------+
        |
        |
        +--- Auswhlen ----- > return mit gewhltem Objekt
  */
  local session:CNC_LIST_KEY;
  local session:CNC_BROWSE_CTRL_KEY;

//session:CNC_SINGLE_STEP_DEBUG := "ON";

  session:CNC_LIST_KEY := session:ARTIKEL_LISTE; // Artikel-Liste von reserviertem Key holen
  action ( "Bestellung#setArtikelFokus" ); // Fokus auf vorher gewhlten Artikel setzen

  while( true ) // Endlos-Schleife
  {
    jsp ( "/bestellapplication/artikel/artikelliste.jsp" );

    if ( cnc_button == "edit" ) // Artikel Editieren
    {
      action ( "listElementToForm" ); // gewhltes Listenelement auf CNC_FORM_KEY kopieren
      session:EDIT_MODE := true; // Merker fr if-tags im JSP auf EDIT setzen

      reset ( "session:FORM_VALID" );

      do ( session:FORM_VALID == null ) // wiederholen bis valid
      {
        jsp ( "/bestellapplication/artikel/artikelform.jsp" );
        if ( cnc_button == "no_parse" ) // Abbruch-Button
        {
          break;
        }
        action ( "Bestellung#validArtikelEdit" ); // Eingabe prfen
      } // do

      reset ( "session:EDIT_MODE" );
    }
    else if ( cnc_button == "add" ) // Artikel Hinzufgen
    {
      session:CNC_FORM_KEY := newObject( "de.cncdemo.formbeans.ArtikelFormBean" ); // neues Listenelement auf CNC_FORM_KEY erzeugen
      session:EDIT_MODE := false; // Merker fr if-tags im JSP auf ADD setzen

      reset ( "session:FORM_VALID" );
      do ( session:FORM_VALID == null ) // wiederholen bis valid
      {
        jsp ( "/bestellapplication/artikel/artikelform.jsp" );
        if ( cnc_button == "no_parse" ) // Abbruch-Button
        {
          break;
        }
        action ( "Bestellung#validArtikelAdd" ); // Eingabe prfen
      } // do

      reset ( "session:EDIT_MODE" );
      if ( cnc_button == "no_parse" ) // Abbruch-Button
      {
        continue;
      }

      action ( "addFormToList" );
      action ( "goLastPage" );

    } // elseif
    else if ( cnc_button == "delete" )
    {
      //action ( "listElementToForm" ); // gewhltes Listenelement auf CNC_FORM_KEY kopieren
      session:CNC_FORM_KEY := session:CNC_LIST_KEY[ cnc_button_index ]; // gewhltes Listenelement auf CNC_FORM_KEY kopieren
      jsp ( "/bestellapplication/artikel/artikeldeleteask.jsp" );
      if ( cnc_button == "no_parse" ) // Abbruch-Button
      {
        continue;
      }
      action ( "deleFormListElement" );

    } // elseif
    else if ( cnc_button == "wahl" )
    {
      action ( "listElementToForm" ); // gewhltes Listenelement auf CNC_FORM_KEY kopieren
//session:CNC_SINGLE_STEP_DEBUG := "ON";
      return ( session:CNC_FORM_KEY );
    } // elseif
    else if ( cnc_button == "no_parse" ) // Abbruch-Button
    {
      return ( null );
    }
  } // end while
} // end procedure artikelstamm
//****************************************************************************************
procedure farbwahl()
{
  session:fgrRed := "0" ;
  session:fgrGreen := "0" ;
  session:fgrBlue := "0" ;

  session:bgrRed := "255" ;
  session:bgrGreen := "255" ;
  session:bgrBlue := "255" ;

  session:alinkRed := "0" ;
  session:alinkGreen := "0" ;
  session:alinkBlue := "0" ;

  session:avisitedRed := "0" ;
  session:avisitedGreen := "0" ;
  session:avisitedBlue := "0" ;

  session:ahoverfgrRed := "255" ;
  session:ahoverfgrGreen := "255" ;
  session:ahoverfgrBlue := "255" ;

  session:ahoverbgrRed := "0" ;
  session:ahoverbgrGreen := "64" ;
  session:ahoverbgrBlue := "128" ;

  session:aactiveRed := "0" ;
  session:aactiveGreen := "0" ;
  session:aactiveBlue := "0" ;

  while(true) //Endlos-Schleife
  {
    jsp ( "/color/color.jsp" ) ;

    //Verzweigung zum Feststellen ob der Button fuer Vordergrund, Hintergrund oder eine andere Style-Komponente gilt (color)
    if ( startsWith( cnc_button , "fgr" ) )
    {
      call styleColor ( session:fgrRed , session:fgrGreen , session:fgrBlue ) ;
    }
    else if ( startsWith( cnc_button , "bgr" ) )
    {
       call styleColor ( session:bgrRed , session:bgrGreen , session:bgrBlue ) ;
    }
    else if ( startsWith( cnc_button , "alink" ) )
    {
       call styleColor ( session:alinkRed , session:alinkGreen , session:alinkBlue ) ;
    }
    else if ( startsWith( cnc_button , "avisited" ) )
    {
       call styleColor ( session:avisitedRed , session:avisitedGreen , session:avisitedBlue ) ;
    }
    else if ( startsWith( cnc_button , "ahoverfgr" ) )
    {
       call styleColor ( session:ahoverfgrRed , session:ahoverfgrGreen , session:ahoverfgrBlue ) ;
    }
    else if ( startsWith( cnc_button , "ahoverbgr" ) )
    {
       call styleColor ( session:ahoverbgrRed , session:ahoverbgrGreen , session:ahoverbgrBlue ) ;
    }
    else if ( startsWith( cnc_button , "aactive" ) )
    {
       call styleColor ( session:aactiveRed , session:aactiveGreen , session:aactiveBlue ) ;
    }
    else
    {
      session:CNC_INFO_MESSAGE := "Programmfehler in farbwahl" ;
    } // else
  } // while
} //end procedure farbwahl
//****************************************************************************************
procedure styleColor ( refparam session:colorPartRed , refparam session:colorPartGreen , refparam session:colorPartBlue )
{

//jsp ( "/cncdebug/show.jsp" );

   //Verzweigung zum Feststellen der Farb-Komponente (colorPart Red, Green oder Blue) der Button gilt
   if ( contents( cnc_button , "Red" ) )
   {
     call colorPart ( session:colorPartRed ) ;
   }
   else if ( contents( cnc_button , "Green" ) )
   {
     call colorPart ( session:colorPartGreen ) ;
   }
   else if ( contents( cnc_button , "Blue" ) )
   {
     call colorPart ( session:colorPartBlue ) ;
  }
   else
   {
     session:CNC_INFO_MESSAGE := "Programmfehler in styleColor" ;
   }

//jsp ( "/cncdebug/show.jsp" );

} //end procedure styleColor
//****************************************************************************************
procedure colorPart( refparam session:colorPartActual )
{

//jsp ( "/cncdebug/show.jsp" );

  //Verzweigung zum Feststellen des Button
  if ( endsWith ( cnc_button , "Set0" ) )
  {
    call colorButton ( session:colorPartActual , "Set0" ) ;
  }
  else if ( endsWith ( cnc_button , "Dec" ) )
  {
     call colorButton ( session:colorPartActual , "Dec" ) ;
  }
  else if ( endsWith ( cnc_button , "Dec8" ) )
  {
     call colorButton ( session:colorPartActual , "Dec8" ) ;
  }
  else if ( endsWith ( cnc_button , "Inc" ) )
  {
     call colorButton ( session:colorPartActual , "Inc" ) ;
  }
  else if ( endsWith ( cnc_button , "Inc8" ) )
  {
     call colorButton ( session:colorPartActual , "Inc8" ) ;
  }
  else if ( endsWith ( cnc_button , "Set255" ) )
  {
     call colorButton ( session:colorPartActual , "Set255" ) ;
  }
  else
  {
     session:CNC_INFO_MESSAGE := "Programmfehler in colorPart" ;
  } // else

//jsp ( "/cncdebug/show.jsp" );

} // end procedure colorPart
//****************************************************************************************
//Abarbeitung der Buttons fuer ein Color-Part zum Beispiel fgrRed (color+colorPart)
procedure colorButton ( refparam session:colorPartKey , session:buttonValue )
{

//jsp ( "/cncdebug/show.jsp" );

  if ( session:buttonValue == "Set0" )
  {
    session:colorPartKey := "0" ;
  }
  else if ( session:buttonValue == "Dec" )
  {
    if ( num( session:colorPartKey ) > 0 )
    {
      session:colorPartKey := "" + ( num( session:colorPartKey ) - 1 ) ; // von String zu num und wieder zurck umwandeln
    }
    else
    {
      session:CNC_INFO_MESSAGE := "Minimum erreicht" ;
      session:colorPartKey := "0" ;
     } // else
  }
  else if ( session:buttonValue == "Dec8" )
  {
    if ( num( session:colorPartKey ) > 8 )
    {
      session:colorPartKey := "" + ( num( session:colorPartKey ) - 8 ) ; // von String zu num und wieder zurck umwandeln
    }
    else
    {
      session:CNC_INFO_MESSAGE:="Minimum erreicht" ;
      session:colorPartKey := "0" ;
     }
  }
  else if ( session:buttonValue == "Inc" )
  {
    if ( num( session:colorPartKey ) < 255 )
    {
      session:colorPartKey := "" + ( num( session:colorPartKey ) + 1 ) ; // von String zu num und wieder zurck umwandeln
    }
    else
    {
      session:CNC_INFO_MESSAGE := "Maximum erreicht" ;
      session:colorPartKey := "255" ;
    }
  }
  else if ( session:buttonValue == "Inc8" )
  {
    if ( num( session:colorPartKey ) < 247 )
    {
      session:colorPartKey := "" + ( num( session:colorPartKey ) + 8 ) ; // von String zu num und wieder zurck umwandeln
    }
    else
    {
      session:CNC_INFO_MESSAGE := "Maximum erreicht" ;
      session:colorPartKey := "255" ;
    }
  }
  else if ( session:buttonValue == "Set255" )
  {
    session:colorPartKey := "255" ;
  }
  else
  {
    session:CNC_INFO_MESSAGE := "Programmfehler in colorButton" ;
  } // if
} //end procedure colorButton
//****************************************************************************************
procedure jsp_spreadsheet ()
{
  while ( true )
  {
    if ( session:CNC_LIST_KEY == null )
    {
      //Daten von Datenbank holen
      action ( 'JspSpreadsheet#load' );
    }

    jsp( "/jsp_spreadsheet/jsp_spreadsheet.jsp" );

    if ( cnc_button == 'save' )
    {
      action ( 'JspSpreadsheet#save' );
    }
    else if ( cnc_button == 'add' )
    {
      add( session:CNC_LIST_KEY , newObject( 'de.cncdemo.formbeans.AktieFormBean' ) );

      // zum Ende der Liste blttern
      invokeMethod( session:CNC_BROWSE_CTRL_KEY , "goLast" );
      session:CNC_FOCUS := "name[" + ( length( session:CNC_LIST_KEY ) - 1 ) + "]";
    }
    else if ( cnc_button == 'ins' )
    {
      add( session:CNC_LIST_KEY , newObject( 'de.cncdemo.formbeans.AktieFormBean' ) , cnc_button_index );
      session:CNC_FOCUS := "name[" + cnc_button_index + "]";
    }
    else if ( cnc_button == 'del' )
    {
      // Zwischenspeichern Button-Index, weil der Button-Index nach dem Anzeigen der nchsten JSP nicht mehr im Request ist
      session:listIndex := cnc_button_index;

      //Lschfrage
      session:CNC_INFO_MESSAGE := "Position: " + cnc_button_index + " mit der Aktie " + session:CNC_LIST_KEY[ cnc_button_index ] + " wirklich lschen?";

      jsp( 'generic/del_ask.jsp' );

      if ( cnc_button == 'del' )
      {
        remove( session:CNC_LIST_KEY , session:listIndex );
      }
      session:CNC_FOCUS := "name[" + ( session:listIndex ) + "]";
      session:listIndex := null ;
    }
  } // end while
} // end procedure jsp_spreadsheet
//****************************************************************************************
procedure frame_menu()
{
  jsp( "/frames/frame_menu.jsp" );
}
//****************************************************************************************
procedure frame_empty()
{
  jsp( "empty.jsp" );
}
//****************************************************************************************
//procedure frame_table()
//{
//  jsp( "/frames/frame_table.jsp" );
//}
//****************************************************************************************
procedure frame_table_kunden()
{
  action( "Frames#loadKunden" );
  jsp( "/frames/frame_table.jsp" );
}
//****************************************************************************************
procedure frame_table_lieferanten()
{
  action( "Frames#loadLieferanten" );
  jsp( "/frames/frame_table.jsp" );
}
//****************************************************************************************
// procedure frame_form()
// {
//   jsp( "/frames/frame_form.jsp" );
// }
//****************************************************************************************
procedure frame_form_kunden()
{
  session:CNC_FORM_KEY := session:CNC_LIST_KEY[ num( request:param:index ) ];
  jsp( "/frames/frame_form.jsp" );
}
//****************************************************************************************
procedure frame_form_lieferanten()
{
  session:CNC_FORM_KEY := session:CNC_LIST_KEY[ num( request:param:index ) ];
  jsp( "/frames/frame_form.jsp" );
}
//****************************************************************************************
procedure tree_simple()
{
  /*
     +-------------------+
     |                   |<----------------+
     |     tree.jsp      |                 |
     |                   |  +-----------------------------+
     |                   |  |     implizite Action        |
     |                   |  |                             |
     |                   |  | de.cnc.implicit.TreeActions |
     |                   |  |                             |
     |                   |  +-----------------------------+
     |                   |                 |
     |                   |                 |
     |                   |                 |
     |                   |                 |
     |                   |                 |
     +-------------------+                 |
              |                            |
              +----------------------------+
  */
  session:CNC_TREE_KEY := action( "createTree" );
  jsp ( "/tree_simple/tree.jsp" );
} // end procedure tree
//****************************************************************************************
procedure frame_tree() // diese Prozedur wird von tree_frame_main.jsp aufgerufen
{
  session:CNC_TREE_KEY := action( "createTree" );
  jsp( "/tree_frames/frame_tree.jsp" );
}
//****************************************************************************************
procedure frame_tree_table()
{
  action( "copyNodes" );
  session:CNC_INFO_MESSAGE := "Sub-Node's von " + invokeMethod( session:CNC_FORM_KEY , "getName" );
  jsp( "/tree_frames/frame_tree_table.jsp" );
}
//****************************************************************************************
procedure expression()
{
  while ( true ) // Endlos-Schleife
  {
    jsp ( "/expression/expression.jsp" );
    session:expression := request:param:expression; // eingegebene Expression zwischenspeichern
    if ( cnc_button == "Demo Numbers" )
    {
      session:expression := "1 + 2";
    } // if
    else if ( cnc_button == "Demo Strings" )
    {
      session:expression := "'aaa'+'bbb'";
    } // if
    else if ( cnc_button == "Demo Boolean" )
    {
      session:expression := "true &amp;&amp; ( 1 > 2)";
    } // if
    else if ( cnc_button == "Demo Variable numerisch" )
    {
      session:expression := "var1";
      session:CNC_INFO_MESSAGE := "Numerische Variable var1. Die vorhandenen Variablen sehen Sie auf dem SessionKey expressionRuntimeEnvironment (Debug-Bereich HttpSession)";
    } // else if
    else if ( cnc_button == "Demo Variable String-Array" )
    {
      session:expression := "arr1[1]";
      session:CNC_INFO_MESSAGE := "String-Array-Variable arr1[0..4]. Die vorhandenen Variablen sehen Sie auf dem SessionKey expressionRuntimeEnvironment (Debug-Bereich HttpSession)";
    } // else if
    else if ( cnc_button == "Demo set Variable" )
    {
      session:expression := "setVar( testStr , 'Inhalt testStr' )";
    } // else if
    else if ( cnc_button == "Demo setVarForName" )
    {
      session:expression := "setVarForName( 'testStrForName' , 'Inhalt testStrForName' )";
    } // else if
    else if ( cnc_button == "Demo set Array Variable" )
    {
      session:expression := "setVar( arr1[0] , 'str0 neu gesetzt' )";
    } // else if
    else if ( cnc_button == "Demo Parenthesis" )
    {
      session:expression := "( 1 + ( 3 * 3 ) + 4 ) * 10";
    } // else if
    else if ( cnc_button == "Demo Sequence simple" )
    {
      session:expression := "// Sequenzen sind mehrere Ausdrcke" + newline +
                            "// durch Semikolon getrennt" + newline +
                            "// und in geschwungene Klammern eingeschlossen" + newline +
                            "// zurckgegeben wird immer das Ergebnis des letzten berechneten Ausdruckes" + newline +
                            "" + newline +
                            "{/* Kommentare sind natuerlich auch moeglich */" + newline +
                            " println( 1 ) ; // Kommentare auch am Zeilenende" + newline +
                            " println( 2 ) ;" + newline +
                            " println( 3 ) ;" + newline +
                            " println( 4 ) ;" + newline +
                            " println( 5 ) ;" + newline +
                            " println( 6 ) " + newline +
                            "}";
    } // else if
    else if ( cnc_button == "Demo Sequence mit continue und break" )
    {
      session:expression := "{ i := 0 ;" + newline +
                            "  { println( 'sequ:'+i++ ) ;" + newline +
                            "    if( i < 3 ," + newline +
                            "        contSequ() ," + newline +
                            "        breakSequ( i )" + newline +
                            "       )" + newline +
                            "  } " + newline +
                            "}";

      session:CNC_INFO_MESSAGE := "Testen Sie bitte die continue-Bedingung, dritte Zeile i < x , mit anderen Werten groesser 3";
    } // else if
    else if ( cnc_button == "Demo while und else if" )
    {
      session:expression := "{ i := 0 ;" + newline +
                            "  // while als Funktion" + newline +
                            "  while( i < 3 ," + newline +
                            "    // if als Funktion" + newline +
                            "    { if( i < 1 ," + newline +
                            "        println( 'i ist kleiner als 1' ) ," + newline +
                            "        if( i < 2 ," + newline +
                            "          println( 'i ist kleiner als 2' ) ," + newline +
                            "          println( 'i ist groesser gleich 2' )" + newline +
                            "        )" + newline +
                            "      ) ;" + newline +
                            "      i++" + newline +
                            "    }" + newline +
                            "  ) " + newline +
                            "}";
      session:CNC_INFO_MESSAGE := "Eine while-Schleife bietet dem geschachtelten if-Verteiler die Variable i im Bereich von 0 bis 2 an";
    } // if
    else if ( cnc_button == "Demo for 1" )
    {
      session:expression := "// for als Funktion" + newline +
                            "for( i := 0 , i < 10 , i++ , println( 'for: '+i ) )";
      session:CNC_INFO_MESSAGE := "Die Notation der for-Funktion lautet: for( startExpression , conditionExpression , stepExpression , bodyExpression )";
    } // else if
    else if ( cnc_button == "Demo for 2" )
    {
      session:expression := "// for als Funktion" + newline +
                            "for( i := 0 , i < 10 , null , println( 'for: '+i++ ) )";
      session:CNC_INFO_MESSAGE := "So geht es auch. Die Notation der for-Funktion lautet: for( startExpression , conditionExpression , stepExpression , bodyExpression )";
    } // else if
    else if ( cnc_button == "Demo Repeat" )
    {
     session:expression := "{ x := 0 ;" + newline +
                           "  // repeat als Funktion repeat-until (pascal style) statt do-while" + newline +
                           "  repeat( x > 0 ," + newline +
                           "    { println( 'tu solange x > 0, aber mindestens einmal' ) ;" + newline +
                           "      x--" + newline +
                           "    }" + newline +
                           "  ) " + newline +
                           "}";
      session:CNC_INFO_MESSAGE := "Ausfhrung der Body-Expression solange der erste Parameter true ist, aber mindestens einmal";
    } // else if
    else if ( cnc_button == "Demo Index-Operator" )
    {
      action( "setArrListMap" );
      session:expression := "{ // Abfrage" + newline +
                            "  println( arrListMap[ 0 , 0 , 'A' ] ) ;" + newline +
                            "" + newline +
                            "  // Zuweisung" + newline +
                            "  arrListMap[ 0 , 0 , 'A' ] := 'Test1' ;" + newline +
                            "  println( arrListMap[ 0 , 0 , 'A' ] ) ;" + newline +
                            "}";
      session:CNC_INFO_MESSAGE := "Abfragen und Zuweisen einer Collection-Variable mit Index-Operator"
                                 + "<br>Die action setArrListMap hat folgende Struktur erzeugt:"
                                 + "<br> Array -> ArrayList -> HashMap";
    }
    else if ( cnc_button == "Demo Kompilieren String" )
    {
      session:expression := "{ //String mit highComma-Key-words zusammengebaut statt escape-zeichen" + newline +
                            "  strExp1 := highComma+'3 + 4'+highComma ;" + newline +
                            "  println( strExp1 ) ;" + newline +
                            "" + newline +
                            "  //Interpretieren eines Strings mit Hochkommas als String und Kompilieren des Strings" + newline +
                            "  exp1 := compile( strExp1 ) ;" + newline +
                            "  println( eval( exp1 ) ) ;" + newline +
                            "" + newline +
                            "  //Ausfhren des im kompilierten String enthaltenen Ausdruckes" + newline +
                            "  exp2 := eval( exp1 ) ;" + newline +
                            "  println( eval( exp2 ) )" + newline +
                            "}";
      session:CNC_INFO_MESSAGE := "1. Kompilieren String,<br>2. Zuweisen zu einer Variable,<br>3. Ausfuehren Expression aus Variable";
    } // else if
    else if ( cnc_button == "Demo Abfangen Fehler" )
    {
      session:expression := "//trycatch als Funktion" + newline +
                            "trycatch( 1 + varNotExist , 'gescheitert' )";
      session:CNC_INFO_MESSAGE := "Ausfhrung eines Ausdruckes mit try-catch-Abfangung und Lieferung des Ersatzwertes, wenn gescheitert";
    } // else if
    else if ( cnc_button == "Demo new String Array" )
    {
      session:expression := "{ arrx := newStringArray( 's0' , 's1' , 's2' ) ;" + newline +
                            "  println( arrx[ 0 ] ) ;" + newline +
                            "  println( arrx[ 1 ] ) ;" + newline +
                            "  println( arrx[ 2 ] ) " + newline +
                            "}";
    } // else if
    else if ( cnc_button == "Demo Zuweisungsoperatoren" )
    {
      session:expression := "{ n := 1 ;" + newline +
                            "  println( ' n := 1 => ' + n ) ;" + newline +
                            " " + newline +
                            "  n += 1 ;" + newline +
                            "  println( ' n += 1 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  s := 's1' ;" + newline +
                            "  println( ' s := '+highComma+'s1'+highComma+' => ' + s ) ;" + newline +
                            " " + newline +
                            "  s += 's2' ;" + newline +
                            "  println( ' s += '+highComma+'s2'+highComma+' => ' + s ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 10 ;" + newline +
                            "  println( ' n := 10 => ' + n ) ;" + newline +
                            "  n -=  1 ;" + newline +
                            "  println( ' n -=  1 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 3 ;" + newline +
                            "  println( ' n := 3 => ' + n ) ;" + newline +
                            "  n *= 2 ;" + newline +
                            "  println( ' n *= 2 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 4 ;" + newline +
                            "  println( ' n := 4 => ' + n ) ;" + newline +
                            "  n /= 2 ;" + newline +
                            "  println( ' n /= 2 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            "  println( ' Zuweisung wenn kleiner' ) ;" + newline +
                            "  n := 4 ;" + newline +
                            "  println( ' n := 4 => ' + n ) ;" + newline +
                            "  n :>= 2 ; // Zuweisung wenn kleiner" + newline +
                            "  println( ' n :>= 2 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 4 ;" + newline +
                            "  println( ' n := 4 => ' + n ) ;" + newline +
                            "  n :min= 2 ; // Zuweisung wenn kleiner" + newline +
                            "  println( ' n :min= 2 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 2 ;" + newline +
                            "  println( ' n := 2 => ' + n ) ;" + newline +
                            "  n :>= 4 ; // Zuweisung wenn kleiner" + newline +
                            "  println( ' n :>= 4 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 2 ;" + newline +
                            "  println( ' n := 2 => ' + n ) ;" + newline +
                            "  n :min= 4 ; // Zuweisung wenn kleiner" + newline +
                            "  println( ' n :min= 4 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            "  println( ' Zuweisung wenn groesser' ) ;" + newline +
                            "  n := 4 ;" + newline +
                            "  println( ' n := 4 => ' + n ) ;" + newline +
                            "  n :<= 2 ; // Zuweisung wenn groesser" + newline +
                            "  println( ' n :<= 2 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 4 ;" + newline +
                            "  println( ' n := 4 => ' + n ) ;" + newline +
                            "  n :max= 2 ; // Zuweisung wenn groesser" + newline +
                            "  println( ' n :max= 2 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 2 ;" + newline +
                            "  println( ' n := 2 => ' + n ) ;" + newline +
                            "  n :<= 4 ; // Zuweisung wenn groesser" + newline +
                            "  println( ' n :<= 4 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '.' ) ;" + newline +
                            " " + newline +
                            "  n := 2 ;" + newline +
                            "  println( ' n := 2 => ' + n ) ;" + newline +
                            "  n :max= 4 ; // Zuweisung wenn groesser" + newline +
                            "  println( ' n :max= 4 => ' + n ) ;" + newline +
                            " " + newline +
                            "  println( '' ) " + newline +
                            "}";
    } // else if
    else if ( cnc_button == "Demo Erzeugen Objekt" )
    {
      session:expression := "date1 := newObject( 'java.util.Date' )";
      session:CNC_INFO_MESSAGE := "Erzeugen eines beliebigen Objektes mit dem paramterlosen Konstruktor";
    } // else if
    else if ( cnc_button == "Demo Template1" )
    {
      session:expression := "eval( " + newline +
                            " compileTemplate( " + newline +
                            "  " + apostroph + "aaa <%= 'bbb' %> ccc" + apostroph + newline +
                            " ) " + newline +
                            ")";
      session:CNC_INFO_MESSAGE := "Kompilieren und Ausfhren eines JSP-hnlichen Templates<br>" +
                                  "&lt;% ...scriptlet code... %&gt; <br>" +
                                  "&lt;%= ...scriptlet expression... %&gt;" ;
    } // else if
    else if ( cnc_button == "Demo Template2" )
    {
      session:expression := "eval( " + newline +
                            " compileTemplate( " + newline +
                            "  " + apostroph + "aaa <% for( i := 0 , i <= 3 , i++ , { %>bbb <% } ) ;%>ccc" + apostroph + newline +
                            " ) " + newline +
                            ")";
      session:CNC_INFO_MESSAGE := "Kompilieren und Ausfhren eines JSP-hnlichen Templates<br>" +
                                  "&lt;% ...scriptlet code... %&gt; <br>" +
                                  "&lt;%= ...scriptlet expression... %&gt;" ;
    } // else if
    else if ( cnc_button == "Demo Template3" )
    {
      session:expression := "eval( " + newline +
                            " compileTemplate( " + newline +
                            "  " + apostroph + "a <% for( i1 := 0 , i1 <= 3 , i1++ ," + newline +
                            "   { for( i2 := 0 , i2 <= 3 , i2++ , { %>b<% } ) ;" + newline +
                            "   { %>_<% } }" + newline +
                            "  ) ;%> c" + apostroph + newline +
                            " ) " + newline +
                            ")";
      session:CNC_INFO_MESSAGE := "Kompilieren und Ausfhren eines JSP-hnlichen Templates<br>" +
                                  "&lt;% ...scriptlet code... %&gt; <br>" +
                                  "&lt;%= ...scriptlet expression... %&gt;" ;
    } // else if
    else if ( cnc_button == "Demo Template4" )
    {
      session:expression := "eval( " + newline +
                            " compileTemplate( " + newline +
                            "  " + apostroph + "a <% " + newline +
                            "    for( i1 := 0 , i1 <= 3 , i1++ , " + newline +
                            "     { %>b<% " + newline +
                            "      for( i2 := 0 , i2 <= 3 , i2++ , { %>c<% } ) ;" + newline +
                            "      %> <%" + newline +
                            "     }" + newline +
                            "    ) ;" + newline +
                            "   %> d" + apostroph + newline +
                            " ) " + newline +
                            ")";
      session:CNC_INFO_MESSAGE := "Kompilieren und Ausfhren eines JSP-hnlichen Templates<br>" +
                                  "&lt;% ...scriptlet code... %&gt; <br>" +
                                  "&lt;%= ...scriptlet expression... %&gt;" ;
    } // else if
    else if ( cnc_button == "Demo Objekt-Attribute lesen und schreiben" )
    {
      session:expression := "{" + newline +
                            "  test        := newObject( 'de.cnc.expression.Test' );" + newline +
                            "  test.tstStr := 'abc';" + newline +
                            "  test.tstStr;" + newline +
                            "}";
      session:CNC_INFO_MESSAGE := "Setzen und Abfragen eines Attributes eines Objektes mit dem Punkt-Operator";
    } // else if
    else if ( cnc_button == "Demo Methoden-Aufruf" )
    {
      session:expression := "{" + newline +
                            "  test := newObject( 'de.cnc.expression.Test' );" + newline +
                            "  test.setTstStr( 'Xyz' );" + newline +
                            "  test.tstStr;" + newline +
                            "}";
      session:CNC_INFO_MESSAGE := "Aufruf einer Methode eines Objektes mit dem Punkt-Operator";
    } // else if
    else if ( cnc_button == "Eval Expression" )
    {
      action ( "expression" );
    } // else if
    else
    {
      session:CNC_ERROR_MESSAGE := "Programmfehler, unbekannte Aktion";
    }
  } // while
} // end procedure expression
//****************************************************************************************
