<%@ page language="java" %>
<%@ page errorPage="/errorpge.jsp"%>
<%@ page contentType="text/html; charset=ISO-8859-1" %>
<%@ taglib uri="/WEB-INF/cnc.tld" prefix="cnc" %>
<%@ taglib uri="/WEB-INF/cncdemo.tld" prefix="cncdemo" %>
<%@ page import="de.cnc.util.StringUtil" %>
<cncdemo:checkuser forsection="color"/>
<cnc:nocache/>
<%!
static String colorHexString(HttpSession session, String colorStr ) {
  return
     StringUtil.toHexTwoDigits(""+session.getAttribute(colorStr+"Red"))
    +StringUtil.toHexTwoDigits(""+session.getAttribute(colorStr+"Green"))
    +StringUtil.toHexTwoDigits(""+session.getAttribute(colorStr+"Blue"));
}
%>
<html lang="de">
 <head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<style type="text/css">
<%--
	hr
	{width="1px"; color:#d5d5d5}
	body,p
	 { font-family:,Arial,Helvetica,sans-serif; font-size:10pt;}
	select
	{ font-family:,Arial,Helvetica,sans-serif; font-size:8pt;}
	td
	 { font-family:Arial,Helvetica,sans-serif; color:#000000;font-size:8pt;}
	.in
	{font-family:Arial,Helvetica,sans-serif; font-size:10pt;color:#000000;border:none;}
	.btn
	{font-family:Verdana,Arial,Helvetica,sans-serif; font-size:8pt;}
	.blueTab
	{font-family:Arial,Helvetica,sans-serif; color:#f0f0f0;background-color:#31659C; font-size:8pt;}
	.blueTabBold
	{font-family:Arial,Helvetica,sans-serif; color:#f0f0f0;background-color:#31659C; font-size:14pt;}
--%>
	a:link
	 { color:#<%=colorHexString(session, "alink")%>; text-decoration:none; font-weigth:bold}
	a:visited
	 { color:#<%= colorHexString(session, "avisited")%>; text-decoration:none; font-weigth:bold}
	a:hover
	 { color:#<%=colorHexString(session, "ahoverfgr")%>; text-decoration:none; font-weigth:bold;background-color:#<%=colorHexString(session, "ahoverbgr")%>}
	a:active
	 { color:#<%=colorHexString(session, "aactive")%>; text-decoration:none; font-weigth:bold}
</style>
<title>CnC Demo color.jsp</title>
</head>
  <body text="#<%=colorHexString(session, "fgr")%>"
        bgcolor="#<%=colorHexString(session, "bgr")%>">
<%-- <body bgcolor="#663333" text="#FFCC99" link="#FF9966" vlink="#FF9900" alink="#FFFFFF"> --%>
  <p>Bitte nicht den Zur&uuml;ck-Button benutzen oder ein neues Fenster &ouml;ffnen sowie kompletten Bildaufbau abwarten.</p>
  <table border="0">
   <tr>
     <%-- seitliche Navigationsleiste --%>
     <%@include file="/sidenav.jsp"%>
    <td>
     <%-- Daten-Bereich --%>
     <table border="0">
      <tr>
       <td colspan="26">
        <h1>Farbwahl Demo CnC</h1>
        <cnc:message/>
       </td>
      </tr>
      <cnc:form action="farbwahl_form"/>

<% String[] strArrColorName = new String[] { "Vordergrund" , "Hintergrund" , "Link" ,  "Link besucht" , "Link Hover Vordergrund" , "Link Hover Hintergrund" , "Link aktiv" } ;
   String[] strArrColorKey = new String[] {  "fgr" ,         "bgr" ,         "alink" , "avisited" ,     "ahoverfgr" ,              "ahoverbgr" ,              "aactive" } ;
   for ( int iColor = 0 ; iColor < strArrColorName.length ; iColor++ ) {
     String strColorName = strArrColorName[ iColor ] ;
     String strColorKey   = strArrColorKey[ iColor ] ;
%>
      <tr>
       <td colspan="26">
        <hr/>
       </td>
      </tr>

       <tr>
         <td colspan="26">
          <b><u><%=strColorName%>:</u></b>
         </td>
       </tr>
       <tr>
<% String[] strArrColorPartName = new String[] { "Rot" , "Gr&uuml;n" , "Blau" } ;
   String[] strArrColorPartKey   = new String[] { "Red" , "Green" , "Blue" } ;
   for ( int iColorPart = 0 ; iColorPart < strArrColorPartName.length ; iColorPart++ ) {
     String strColorPartName = strArrColorPartName[ iColorPart ] ;
     String strColorPartKey   = strArrColorPartKey  [ iColorPart ] ;

%>
        <td colspan="6">
         <%=strColorPartName%>: <cnc:input type="text" property="<%=strColorKey+strColorPartKey%>" size="3" sessionvalue="true"/>
         &nbsp;#<%=StringUtil.toHexTwoDigits(""+session.getAttribute(strColorKey+strColorPartKey))%>
        </td>
<% if ( iColorPart < strArrColorPartName.length - 1 ) { // nicht beim letzten ColorPart %>
        <td>
         &nbsp;
        </td>
<% } // if %>
<% } // for iColorPart %>
       </tr>

       <tr>
<%  for ( int iColorPart = 0 ; iColorPart < strArrColorPartName.length ; iColorPart++ ) {
      String strColorPartKey   = strArrColorPartKey  [ iColorPart ] ;

      String[] strArrButtonName  = new String[] { "Set0" , "Dec8" , "Dec" , "Inc" , "Inc8" , "Set255" } ;
      String[] strArrButtonValue = new String[] { "0" , "--" , "-" , "+" , "++" , "255" } ;

      for ( int iButton = 0 ; iButton < strArrButtonName.length ; iButton++ ) {
        String strButtonName  = strArrButtonName [ iButton ] ;
        String strButtonValue = strArrButtonValue[ iButton ] ;
%>
        <td>
         <cnc:button name="<%=strColorKey+strColorPartKey+strButtonName%>" value="<%=strButtonValue%>"/>
        </td>
<% } // for iButton %>
<% if ( iColorPart < strArrColorPartName.length - 1 ) { // nicht beim letzten ColorPart %>
        <td>
         &nbsp;
        </td>
<% } // if %>
<% } // for iColorPart %>
       </tr>
<% } // for iColor %>

      </form>
     </table>
    </td>
   </tr>
  </table>
  </form>
  <cnc:debug/>
 </body>
</html>
