<%@ page isErrorPage="true" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="de.cnc.util.*" %>
<%@ page contentType="text/html; charset=ISO-8859-1" %>

<%@ page language="java" %>
<%@ taglib uri="/WEB-INF/cnc.tld" prefix="cnc" %>
<%@ taglib uri="/WEB-INF/cncdemo.tld" prefix="cncdemo" %>
<cnc:nocache/>

<meta http-equiv="expires" content="0">
<meta http-equiv="pragma" content="no-cache">
<html>
<head>
 <title>Control and Command Error Page</title>
  <link rel="stylesheet" type="text/css" href="cnc.css">
</head>

<body>

<%
  if (exception == null)
  {
    exception = (Throwable) session.getAttribute("CNC_EXCEPTION");
  }
%>

<h3>Control and Command Exception <%=exception%></h3>

<%
 String msg = exception.getMessage();
 if (msg != null && msg.length() > 0 ){
%>
<strong>reason:</strong><br>
<%=msg%><p>
<%
 }
%>


<strong>callstack:</strong>
<pre>
<% exception.printStackTrace(new PrintWriter(out));%>
</pre>

<strong>jsp page:</strong>
<pre>
<%= request.getRequestURI() %>
</pre>

<h3>Parameter</h3>
<pre>
<%
  Enumeration pn = request.getParameterNames();
  while ( pn.hasMoreElements() ) {
    String parName = (String) pn.nextElement() ;
	  Object parValue = request.getParameter( parName ) ;
%>
<%= parName %>: <%= parValue %>

<% } %>
</pre>


<h3>URL</h3>
<%-- =HttpUtils.getRequestURL(request).toString() --%>
<%= request.getRequestURI() %>

</body>
</html>



<%
  // print error to logfile
  Log.log( "[JSP] " + msg + " <url: " + HttpUtils.getRequestURL(request).toString() + ">" , Log.FATAL ) ;
  //Log.fatal((Exception)exception);
  Log.fatal( exception );
%>

<cnc:debug/>

<%
//CncUtil.invalidate( session ) ;
session.invalidate() ; // weiterarbeiten bei Fehler verhindern
%>
