<%@ page language="java" %>
<%@ page errorPage="/errorpge.jsp"%>
<%@ page contentType="text/html; charset=ISO-8859-1" %>
<%@ taglib uri="/WEB-INF/cnc.tld" prefix="cnc" %>
<cnc:nocache/>
<% de.cnc.util.CncUtil.removeAll( session ) ; //Status zurcksetzen, falls der Home-Buton des Browsers benutzt wurde%>
<html lang="de">
 <head>
  <title>CnC Demo welcome.jsp</title>
  <link rel="stylesheet" type="text/css" href="cnc.css">
  <meta name="DC.Date" content="<%= "" + new java.util.Date() %>">
  <meta name="Date" content="<%= "" + new java.util.Date() %>">
 </head>
 <body>
  <body bgcolor="#FFFFFF">
  <h1>Willkommen beim Demo Control and Command</h1>
  <cnc:message/>
   <table>
    <tr>
     <td>
      <a href="http://www.heinerkuecker.de/Cnc.html">CnC Home<a>
     </td>
    </tr>
    <tr>
     <td>
      &nbsp;
     </td>
    </tr>
    <tr>
     <td>
      <a href="http://www.df-webhosting.de">Hosted by D&F-Webhosting (Tomcat 5)<a>
     </td>
    </tr>
    <tr>
     <td>
      &nbsp;
     </td>
    </tr>
    <tr>
     <td>
      <cnc:href href="weiter" txt="Herein, Come in"/>
     </td>
    </tr>
    <tr>
     <td>
      &nbsp;
     </td>
    </tr>
    <tr>
     <td>
<b>
Das Framework Control and Command ist eine Fluss-Steuerung fr JSP- und Servlet-Applikationen.<br>
Es beruht auf einer eigenen Scriptsprache und besitzt Strukturen, Befehle, Unterprogramme,<br>
lokale Variable und Parameter (per value/reference).<br><br>
The Framework Control and Command is an JSP FlowControl Workflow PageFlow Engine
for JSP- und Servlet-Applications.<br>
CnC based on a own Scriptlanguage and has struktures, instructions, subprogramms,<br>
local variables and parameters (per value or per reference).<br>
</b>
<pre>
Ein Programm knnte folgendermassen aussehen (see the example code):
<b>
procedure date_range()
{
  while ( true ) // Endlos-Schleife
  {
    session.CNC_MESSAGE_KEY := "Bitte Datum von 1.1.2005 bis 31.12.2005 eingeben";
    jsp ( "/date/date.jsp" );
    session.date := request.param.date; // eingegebenes Datum zwischenspeichern
    if (   ( strToDate( session.date ) &gt;= strToDate( "1.1.2004" ) )  // if date &gt;= 01.01.2004
        && ( strToDate( session.date ) &lt;= strToDate( "31.12.2004" ) ) ) // if date &lt;= 31.12.2004
    {
      session.CNC_MESSAGE_KEY := 'Datum "' + trim( session.date ) + '" ist korrekt'; // Setzen Meldung
      jsp ( "/cncdebug/show.jsp" );
      break; // Schleife beenden
    } // if
  } // while
} // end procedure daterange
</b>

Architektur CnC
===============

Kompilieren:
------------

     Steuerdatei
      flow.cnc
         |
   wird gelesen von
         |
  FlowControlParser
         |
      erzeugt
         |
   FlowControlTable ---- enthlt ---- > FlowControlInstruction


Ablauf:
-------

    +------- > FlowControl --- benutzt --- > FlowControlTable --- enthlt --- > FlowControlInstruction
    |           |     |
    |        startet ruft
    |           |     |
    |          JSP    +--- > ActionMethoden (z.B. CncDemoDefaultActions)
    |           |
    |         ruft (Browser HTTP-Request)
    |           |
    |       CncServlet --- erweitert durch --- > Applikations-Servlet (z.B. CncDemoServlet)
    |           |
    |  bergibt die Steuerung an
    |           |
    +-----------+



Hier geht es zum Demo-Programm.

Fr den Einzelschritt-Debug-Modus mssen Cookies eingeschaltet sein, sonst nicht.

Benutzen Sie bitte nicht den Back-Button und ffnen Sie kein neues Browser-Fenster,
da die Fhrungsmethode <b>sessionleading</b> gesetzt ist.

Zum Ansehen der Debug-Informationen mssen Sie im Fenster nach unten rollen.
Hilfreich ist hier beim IE der Vollbildmodus (F11).
</pre>
       </td>
      </tr>
   </table>
   <cnc:href href="weiter" txt="Herein, Come In"/>
<br>
<br>
<br>
<br>
<br>
<br>
Heiner Kcker<br>
<a href="http://www.heinerkuecker.de">www.heinerkuecker.de</a>  <a href="http://www.heiner-kuecker.de">www.heiner-kuecker.de</a><br>
<a href="http://www.control-and-command.de">JSP WorkFlow PageFlow Page Flow FlowControl Navigation</a> <br>
<a href="http://www.heinerkuecker.de/Expression.html">Expression Language Parser</a> <br>
<br>
 </body>
</html>
