package de.cnc;

import de.cnc.domainparser.util.SourcePosition;
import de.cnc.flowcompiler.ParserException;
import de.cnc.util.StringUtil;

public class FlowControlUtil 
{

	/**
	 * Reklamieren Fehler in der Flusskontroll-XML-Datei
	 *
	 * @throws RuntimeException mit Error-Description
	 */
	public static void complain(String text, SourcePosition pScrPos)
	{
	    // throw new RuntimeException( text +
	    // throw new ParserException(text + " Line: " + parser.getLineNumber() + " Col: " + parser.getColumnNumber());
	    throw new ParserException(text + " Line: " + pScrPos.getRow() + " Col: " + pScrPos.getCol());
	}// end method complain

    /**
     * Prfen auf den Prefix 'session:' und Abschneiden des Prefix.
     * 
     * TODO : diese Mimik wird auch fr application-Scope bentigt
     * 
     * @param pStrVarName
     * @param pSourcePosition
     * @return
     */
	public static String checkAndCutPrefixSession(
		String pStrVarName,
		SourcePosition pSourcePosition) {
		if ( ! StringUtil.startsWith( pStrVarName , "session:" ) )
		{
            (new Exception()).printStackTrace();
		    FlowControlUtil.complain( "parameter prefix 'session:' expected: " + pStrVarName , pSourcePosition );
		}
		
		String sessKey = StringUtil.cutLeft( pStrVarName , "session:" );
		return sessKey;
	}}
