package de.cnc.expression.exceptions;




/**
 * HilfsException zur Realisierung von breakSequ . <br>
 * Transportiert den Rckgabewert ber ein Cargo-Object.<br>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
// noch umwandeln in eine checked Exception
public class BreakSequenceException extends RuntimeException /* Exception */{

  protected Object cargoObject;

  /**
   * constructor
   */
  public BreakSequenceException(Object newCargoObject) {
    cargoObject = newCargoObject;
  }// end constructor

  /**
   * get the cargo object
   */
  public Object getCargoObject() {
    return cargoObject;
  }// end method

  // private int iLine;
  // private int iCol;
  // private String strSource;
  // private String strOriginalSource;
  //
  // /**
  // * constructor
  // */
  // public BreakSequenceException(int paIntLine, int paIntCol, String paStrSource, String paStrOriginalSource, String paStrErrorMessage) {
  // super(paStrErrorMessage);
  // iLine = paIntLine;
  // iCol = paIntCol;
  // strSource = paStrSource;
  // strOriginalSource = paStrOriginalSource;
  // }
  //
  // /**
  // * constructor
  // */
  // public BreakSequenceException(AbstractInfixOperator paOp, String paStrMessage) {
  // this(paOp.getLine(), paOp.getCol(), paOp.getSource(), paOp.getOriginalSource(), paStrMessage);
  // }
  //
  // /**
  // * constructor
  // */
  // public BreakSequenceException(AbstractPrePostfixOperator paOp, String paStrMessage) {
  // this(paOp.getLine(), paOp.getCol(), paOp.getSource(), paOp.getOriginalSource(), paStrMessage);
  // }
  //
  // public int getLine() {
  // return iLine;
  // }
  //
  // public int getCol() {
  // return iCol;
  // }
  //
  // public String getMessage() {
  // return super.getMessage() + " line:" + iLine          // line
  // + " col:" + iCol + "\n"     // col
  // // + strSource + "\n"       // source
  // + strOriginalSource + "\n"  // original source entire line
  // + spaces(iCol) + "^\n";   // advice arrow
  // }
  //
  // private static String spaces(int paIntCount) {
  // StringBuffer sb = new StringBuffer();
  //
  // for (int i = 0; i < paIntCount; i++) {
  // sb.append(' ');
  // }
  // return sb.toString();
  // }

}// end class BreakSequenceException
