package de.cnc.expression.util;


import java.util.ArrayList;

import de.cnc.expression.AbstractToken;


/**
 * auf AbstractToken typisierte ArrayList . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class AbstractTokenArrayList {

  /**
   * eigentliche ArrayList
   */
  private ArrayList clArrayList = new ArrayList();

  /**
   * typisiertes get
   */
  public AbstractToken get(int iPaIndex) {
    return (AbstractToken) clArrayList.get(iPaIndex);
  }// end method get

  /**
   * typisiertes letztes Element
   */
  public AbstractToken tail() {
    return (AbstractToken) clArrayList.get(clArrayList.size() - 1);
  }// end method tail

  /**
   * typisiertes add
   */
  public boolean add(AbstractToken strPaValue) {
    return clArrayList.add(strPaValue);
  }// end method add

  /**
   * size
   */
  public int size() {
    return clArrayList.size();
  }// end method size

  /**
   * Debug-Ausgabe
   */
  public String toString() {
    return "" + clArrayList;
  }// end method toString

} // end class AbstractTokenArrayList
