package de.cnc.flowprogram;


import java.util.ArrayList;


/**
 * auf {@link FlowProcCallParam} typisierte ArrayList . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id:$
 */
public class FlowProcParamList {

  /**
   * eigentliche ArrayList
   */
  private ArrayList clList = new ArrayList();

  /**
   * Map mit den Variablen- und Parameter-Namen
   * 
   * mal berarbeiten nur noch Map
   */
  //private HashMap clMap = new HashMap();

  /**
   * typisiertes get
   */
  public FlowProcCallParam get(int iPaIndex) {
    return (FlowProcCallParam) clList.get(iPaIndex);
  }// end method

  /**
   * typisiertes add
   */
  public boolean add(
        FlowProcCallParam strPaValue)
        //SourcePosition pSourcePosition) 
  {
//    if ( clMap.get( strPaValue ) != null )
//    {
//        //Name schon vorhanden
//        FlowControlCompiler.complain( "local or parameter identifier " + strPaValue + " is already declared",
//                                    pSourcePosition);
//    }

//Log.debug( "FlowProcParamList#add strPaValue: >" + strPaValue + "<" );

    return clList.add(strPaValue);
  }// end method

  /**
   * size
   */
  public int size() {
    return clList.size();
  }// end method

  /**
   * Debug-Ausgabe
   */
  public String toString() {
    return "" + clList;
  }// end method

} // end class FlowProcParamList
