package de.cnc.implicit;


import javax.servlet.http.*;

import de.cnc.*;
import de.cnc.util.CncUtil;


/**
 * Implizite Action zum Sortieren einer Tabelle . <br/>
 *
 * </pre>
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner K&uuml;cker</a><br/>
 * <br/>
 *
 * @author Heiner K&uuml;cker
 * @version $Id:$
 * @since 08.09.2004
 */
public class Debug  // implements ImplicitActionInterface 
{

  /**
   * -Action . <br/>
   *
   * @param request  HttpServletRequest  des zentralen Servlets fr Zugriff auf Session und so weiter
   * @param response HttpServletResponse des zentralen Servlets
   *
   * @return String-Rckgabewert fr eventuelle Auswertung
   */
  public static String debugOn(
     int iPaIndex, //--
     HttpServletRequest request, //--
     HttpServletResponse response, //--
     CncContext cncContext)
  {
      HttpSession session = request.getSession(true);

     CncUtil.setAttribute(session, SessionKeys.CNC_SINGLE_STEP_DEBUG, "ON");
      return "";
  }// end method debugOn

} // end class ImplicitAction
