package de.cnc.implicit;

/**
 * Dieses Interface kennzeichnet PersistensBeans,
 * die auf der JSP-Seite markierbar sind.
 * Mit den markierten Zeilen knnen bestimmte Operationen,
 * wie Lschen alle markieten Zeilen, ausgefhrt werden.
 * 
 * @author Heiner Kcker
 */
public interface MarkableInterface
{
   /**
    * @return
    */
   public boolean getMark();

   /**
    * @param pMark
    */
   public void setMark(boolean pMark);

}
