package de.cnc.util;




/**
 * Hilfsklasse hartes warten in Millisekunden . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public final class WaitUtil {

  /**
   * hartes warten in Millisekunden . <br/>
   * Der aktuelle Thread wird ber Thread.sleep() schlafen gelegt. <br/>
   *
   * @param iPaTime Wartezeit in Millisekunden
   */
  public static final void wait(int iPaTime) {
    // Version mit Schleife nicht ntig
    // long endTime = ( new Date() ).getTime() + iPaTime ;
    // while ( endTime > ( new Date() ).getTime() ) {
    // ; // tu nichts
    // }//end while

    try {
      Thread.sleep(iPaTime);
    } catch (Exception e) 
    {} // end catch

  }// end method wait

}// end method WaitUtil
