package de.cnc.util.config;

/**
 * spezifische Exception-Klasse fr Konfiguration
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id:$
 */
public class ConfigurationException extends Exception
{
  public final static String  PropertyNotFound = "Config Property not found: ";
  public final static String  PropertyNotValid = "Config Property is not valid: ";
  public final static String  PropertyIsEmpty = "Config Property is empty: ";

  /**
   * parameterloser Constructor
   */
  public ConfigurationException()
  {
    super();
  }

  /**
   * Constructor fr konkrete Anwendung
   *
   * @param s Spezifikation der zu erzeugenden Exception (siehe Konstanten)
   */
  public ConfigurationException(String s)
  {
    super(s);
  }

}
