package de.cnc.validator;

/**
 * Klasse zum Halten der Fehlermeldungen fr invalide
 * HTML-Form-Felder . <br>
 * 
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public class FormFieldError
{
    /** Name des Property, klein geschrieben */
    private String propertyName;
    
    /** Fehlermeldung */
    private String errMsg;

    public FormFieldError( //--
        final String pPropertyName, //--
        final String pErrMsg)
   {
       propertyName = pPropertyName;
       errMsg = pErrMsg;
   }

        
    /**
     * @return
     */
    public String getErrMsg()
    {
        return errMsg;
    }

    /**
     * @return
     */
    public String getPropertyName()
    {
        return propertyName;
    }

    /**
     * @param string
     */
    public void setErrMsg(String string)
    {
        errMsg = string;
    }

    /**
     * @param string
     */
    public void setPropertyName(String string)
    {
        propertyName = string;
    }

    /**
     * Debug-Ausgabe
     */
    public String toString()
    {
        return this.getClass().getName() //--
        + "[propertyName: " + propertyName //--
        + ", errMsg: " + errMsg + "]";
    }
}
