package de.cncdemo.formbeans;




/**
 * FormBean (Formular-Bean) fr Artikel der Bestell-Demo-Applikation
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public final class ArtikelFormBean {

  /**
   * Property Artikel-Nummer
   */
  private String artNr = "";

  /**
   * Property Bezeichnung
   */
  private String bez = "";

  /**
   * Property Menge
   */
  private double menge;

  /**
   * Property Mengeneinheit
   */
  private String me = "";

  /**
   * get artNr
   *
   * @return artNr
   */
  public String getArtNr() {
    return artNr;
  }// end method getArtNr

  /**
   * set artNr
   *
   * @param artNr new Value
   */
  public void setArtNr(String newArtNr) {
    this.artNr = newArtNr;
  }// end method setArtNr

  /**
   * get bez
   *
   * @return bez
   */
  public String getBez() {
    return bez;
  }// end method getBez

  /**
   * set bez
   *
   * @param bez new Value
   */
  public void setBez(String newBez) {
    this.bez = newBez;
  }// end method setBez

  /**
   * get menge
   *
   * @return menge
   */
  public double getMenge() {
    return menge;
  }// end method getMenge

  /**
   * set menge
   *
   * @param menge new Value
   */
  public void setMenge(double newMenge) {
    this.menge = newMenge;
  }// end method setMenge

  /**
   * set menge
   *
   * @param menge new Value
   */

  /*
   public void setMenge( String newMenge ) {
   this.menge = StringUtil.str2double( newMenge ) ;
   }//end method setMenge
   */

  /**
   * get me
   *
   * @return me
   */
  public String getMe() {
    return me;
  }// end method getMe

  /**
   * set me
   *
   * @param me new Value
   */
  public void setMe(String newMe) {
    this.me = newMe;
  }// end method setMe

  public String toString() {
    return getClass().getName() + " " + "Artikel-Nummer " + artNr + " " + "Bezeichnung " + bez + " " + "Menge " + menge + " "
        + "Mengeneinheit " + me + " ";
  }// end method toString

}// end class ArtikelFormBean
