package de.cncdemo.formbeans;

/**
 * FormBean (Formular-Bean) fr einen Kunden im
 * Frames-Demo in der CncDemo-Applikation . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public final class KundeFormBean
{

    private String nachName;

    private String vorName;

    private String strasseNr;

    private String plz;

    private String ort;

    /**
     * @return
     */
    public String getNachName()
    {
        return nachName;
    }

    /**
     * @return
     */
    public String getOrt()
    {
        return ort;
    }

    /**
     * @return
     */
    public String getPlz()
    {
        return plz;
    }

    /**
     * @return
     */
    public String getStrasseNr()
    {
        return strasseNr;
    }

    /**
     * @return
     */
    public String getVorName()
    {
        return vorName;
    }

    /**
     * @param string
     */
    public void setNachName(String string)
    {
        nachName = string;
    }

    /**
     * @param string
     */
    public void setOrt(String string)
    {
        ort = string;
    }

    /**
     * @param string
     */
    public void setPlz(String string)
    {
        plz = string;
    }

    /**
     * @param string
     */
    public void setStrasseNr(String string)
    {
        strasseNr = string;
    }

    /**
     * @param string
     */
    public void setVorName(String string)
    {
        vorName = string;
    }

    /**
     * Konstruktor
     */
    public KundeFormBean()
    {
    }

    /**
     * Konstruktor
     */
    public KundeFormBean(//--
        final String newNachName, //--
        final String newVorName, //--
        final String newStrasseNr, //--
        final String newPlz, //--
        final String newOrt)
    {
        nachName = newNachName;
        vorName = newVorName;
        strasseNr = newStrasseNr;
        plz = newPlz;
        ort = newOrt;
    }

    /**
     * Debug-Ausgabe
     */
    public String toString()
    {
        return /*getClass().getName() + " " +*/ //--
        "[nachName: " + nachName + //--
        ", vorName: " + vorName + //--
        ", strasseNr: " + strasseNr + //--
        ", plz: " + plz + //--
        ", ort: " + ort + "]";

    }

}
