package de.cncdemo.generic;


/**
 * Hier sind globale Konstanten der CnC-Demo-Applikation hinterlegt . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id$
 */
public interface Constants {

  /**
   * mainmenu.jsp, zentraler Einstieg und Default-Seite der CnC-Demo-Applikation
   */
  public final static String MAIN_MENU_JSP = "/mainmenu.jsp";

  /**
   * logon.jsp, URI der Logon-JSP
   */
  public static final String LOGON_JSP = "/logon.jsp";

  /**
   * Session-Key fr User-Authentifizierung und zugelassene Rollen
   */
  public final static String  USER = "USER";

} // end Interface Constants
